#include <Qt/qstring.h>
#include <vector>

#include "TreeRep.h"


/**
 * class responsible for parsing family tree data
 */
class FamilyTreeParser
{

public:

/**
 * parses the tree data from a given file name
 * @param trep encapsules the abstract data structure tree
 * @param filename path to the input datafile
 * @return true if loading succesful, false otherwise
 */
static bool parse_treedata( TreeRep *trep, QString filename );

/**
 * parses the relationships data from a given file name
 * @param relvec encapsules the vector structer where the relations shall be saved
 * @param filename path to the input datafile
 * @return true if loading succesful, false otherwise
 */
static bool parse_relationdata( std::vector< strRelationshipPair > *trep, QString filename );

};