#include "QFotoCanvas.h"

//bool texset = false;

QFotoCanvas::QFotoCanvas(QWidget* parent /*= 0*/) : QObject(parent), QGLWidget(parent), m_bColorSet( false ), m_TexHandle ( NULL ), m_TreeRep( NULL )
{
	glInit ();
}


QFotoCanvas::~QFotoCanvas()
{

}

void QFotoCanvas::setObjectName(const QString &name)
{
}

void QFotoCanvas::setVolBackColorPtr(VVector *v)
{
	m_bColorSet = true;
	m_ptrCanvasColor = v;
}

void QFotoCanvas::setTexHandlePtr(VImage *h)
{
	m_TexHandle = h;
	//texset = true;
}
void QFotoCanvas::initializeGL()
{
	this->makeCurrent();
	// Set up the rendering context, define display lists etc.:
	//...
	glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glEnable(GL_DEPTH_TEST);
	//...

	paintGL();
}

void QFotoCanvas::resizeGL( int w, int h )
{
	this->makeCurrent();

	glViewport(0, 0, w, h);
	gluOrtho2D(0, w, h, 0);

}

void QFotoCanvas::paintGL()
{	
	this->makeCurrent();

	glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glEnable(GL_DEPTH_TEST);

	// draw the scene:
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	glLoadIdentity();									// Reset The Current Modelview Matrix


	if( m_bColorSet ) 
	{
		m_TreeRep->setupTextures();

		if( m_TexHandle && m_TexHandle->getImageHandle() )
		{

			glEnable( GL_TEXTURE_2D );
			//glActiveTexture( GL_TEXTURE0_ARB );
			glBindTexture( GL_TEXTURE_2D, m_TexHandle->getImageHandle() );
			
			glBegin( GL_QUADS );
				glTexCoord2f( 0.0f, 0.0f );glVertex2f( -1.0f, -1.0f );	
				glTexCoord2f( 1.0f, 0.0f );glVertex2f(  1.0f, -1.0f );	
				glTexCoord2f( 1.0f, 1.0f );glVertex2f(  1.0f,  1.0f );	
				glTexCoord2f( 0.0f, 1.0f );glVertex2f( -1.0f,  1.0f );	
			glEnd();

			//glActiveTextureARB( GL_TEXTURE0_ARB );
			glBindTexture( GL_TEXTURE_2D, 0 );
			glDisable( GL_TEXTURE_2D );
		}
		else
		{
			glColor3fv( m_ptrCanvasColor->getPtr() );
			glBegin( GL_QUADS );
				glVertex2f( -1.0f, -1.0f );
				glVertex2f(  1.0f, -1.0f );
				glVertex2f(  1.0f,  1.0f );
				glVertex2f( -1.0f,  1.0f );
			glEnd();
		}
		

	}

	GLenum err = glGetError(); 

	if (err != GL_NO_ERROR) 
	{ 

		std::cout << "glError in foto canvas: " << gluErrorString(err) << std::endl;
	} 

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glPopAttrib();
}

void QFotoCanvas::redraw()
{
	makeCurrent();
	repaint();
	swapBuffers();
}
void QFotoCanvas::paintEvent( QPaintEvent *e )
{
	QGLWidget::paintEvent(e);
};


