#ifndef _TREE_ENTITY_
#define _TREE_ENTITY_

#include "VImage.h"

#include <string>

/**
 * class representing an entity for a family tree
 */
class TreeEntity
{

public:

/**
 * standard constructor
 */
	TreeEntity() ;

/**
 * standard destructor
 */
	~TreeEntity();

/**
* creates the image
*/
	void createImage();

//entity properties
	int id;				/**< id number. */
	std::string name;	/**< contains the name of the entity. */
	std::string born;	/**< contains optionally the date and place of birth of the entity. */
	std::string died;	/**< contains the date of demise of the entity. */
	int sex;			/**< contains the sex of the entity, 0 for male, 1 for , -1 for unknown. */

//hierarchy properties
	int numchildren;	/**< number of children. */
	int order;			/**< order x means xth child. */

//position properties

	float pos_x, pos_y; /**< position of the node. might be cartesian or polar*/
	float extent;		/**< available extent for the children */

	float cart_x, cart_y; /**< position of the node. must be cartesian*/

// balloon layout
	float innerRadius;  /**< radius of the circle on which children of the node are placed */
	float outerRadius;	/**< radius of the circle surrounding its subtree */
	float angle;		/**< angle reserved for current node. it is used as offset angle for correct placement of children */
	float size;			/**< size of marker of current node. to avoid overlaps. */
	float maxChildRadius;	/**< biggest radius occurring among direct children */
	float estimate;		/**< temporary estimate variable for balloon layout */
	int childCount;		/**< temporary child count for balloon layout*/
	VImage *m_Image;	/**< pointer to the image (foto of an entity*/
	bool m_ImagePresent;	/**< true if there is an image specified*/
	std::string m_ImagePath;	/**< path to the image file which is specified in the data file*/
	bool m_ImageCreated;	/**< true if the texture was already generated for the image*/
};

#endif
