#include "VImage.h"
// #include "VFramebufferObject.h"
// 
// #include "glew.h"
#include "IL/il.h"
#include "IL/ilu.h"
#include "IL/ilut.h"
#include <iostream>
bool devIlInitialised = false;

bool initialiseDevIl()
{
	ilInit();
	iluInit();
	ilutInit();
	ilutRenderer(ILUT_OPENGL);
	if ((ilGetInteger(IL_VERSION_NUM) < IL_VERSION) ||
		(iluGetInteger(ILU_VERSION_NUM) < ILU_VERSION) ||
		(ilutGetInteger(ILUT_VERSION_NUM) < ILUT_VERSION)) 
	{
		std::cout << "devil not working" << std::endl;
		return false;
	}
	devIlInitialised = true;

	return true;
}

bool VImage::loadImage(std::string filename)
{
	if(!devIlInitialised)
	{
		initialiseDevIl();
	}
	
	deleteImage();

	unsigned int ilImageHandle;
	ilGenImages(1, &ilImageHandle);
	ilBindImage(ilImageHandle);
	ilLoadImage(filename.c_str());
	//iluFlipImage();
	m_ImageHandle = ilutGLBindMipmaps();

	
	ilDeleteImages(1, &ilImageHandle);
	if(m_ImageHandle == 0)
	{
		return false;
	}
	return true;
}

void VImage::deleteImage()
{
	if(m_ImageHandle != 0)
	{
		glDeleteTextures(1,&m_ImageHandle);
	}
}
