#pragma once

#ifndef __v_image_h
#define __v_image_h

#include <string>

/**
 * class Handling loading an Image from Disc
 */
class VImage
{
public:

	/**
	 * default constructor
	 */
	VImage() : m_ImageHandle(0)
	{

	}

	/**
	 * default destructor
	 */
	~VImage()
	{
		deleteImage();
	}

	/** 
	 * loads an image from disc
	 * @param filename filename of Image
	 * @return true if loading worked
	 */
	bool loadImage(std::string filename);

	/**
	 * returns the image Handle
	 * @return OpenGl Handle of Image
	 */
	unsigned int getImageHandle()
	{
		return m_ImageHandle;
	}

// 	/**
// 	 * method for testrendering the Image to a small quad
// 	 */
// 	void renderToLowerRightQuad();

private:

	/**
	 * deletes the image
	 */
	void deleteImage();

	unsigned int m_ImageHandle;			/**< Opengl Handle of Image. */
};

#endif //__v_image_h